/*--- MMI.C -------------------------------------------------------------------
function: Man Machine Interface; input and error routines
credits:  FVu, Dec-1998 (freddy@textinfo.nl
*/

#include <stdio.h>
#include "mmi.h"
#include "mmim.h"
#include "ft.h"
#include "wwdb.h"
#include "wlib.h"
#include "vdp.h"
#include "vdpm.h"
#include "neu.h"


						/* INPUT */
char  KPMOD, IBUFMAX;					/* KP_settings */
int   CHKNUM;
VOID  (*ANYFAD)();
char  IBUF[255], *IBUFPNT, *SCIFPNT, SCIFSZ;		/* input_settings */
VOID  (*IPFAD)();					/* common */
						/* ERROR */
char  ERRNUM, ERRREP;					/* error_settings */
VOID  (*RTRFAD)();					/* retry_settings */
char  CNCRET;						/* cancel_settings */
VOID  (*CNCFAD)();
char  eCFTnr;						/* common */
jmp_buf  KPenv;
						/* MUNU */
char  bKeySet;


VOID Cancel() {
   printf("Sometimes I wonder..\n");
   if (CNCRET)
      CFTswitch(eCFTnr);
   else
      CFTswitch((char) 0);
      /* (*CNCFAD)()  Not used yet */
}

VOID Cr() {
   if ((KPMOD & 1) == 1)
      (*IPFAD)();
   else
      GoAction();
}

VOID GoAction() {
   switch (lnType) {
   case _ACOWW:
      OpenWW(lnAction);
      break;
   case _ACFNC:
      (* (VOID (*)()) lnAction)();
      break;
   }
}

VOID ErrorShow() {
   eCFTnr = bCFTnr;
   if (ERRREP) {
      fputs ("Program failure.. Retry, Cancel?\n", stderr);
      CFTswitch(tfcERROR);
   }
   else {
      fputs ("Program failure.. Press any key.\n", stderr);
      KPMOD =0x08; ANYFAD =Nothing;
      CFTswitch((char) 0);
   }
   longjmp(KPenv);
}

VOID Escape() {
   if (wwPrev != NULL)
      CloseWW();
   else
      EndMnu();
}

VOID IFPadjust() {				/* Adjust Inputfield Pointer */
   if (IBUFPNT > SCIFPNT + SCIFSZ) {
       SCIFPNT = IBUFPNT - SCIFSZ;
       if (SCIFPNT > IBUF + IBUFMAX - SCIFSZ)
	  SCIFPNT = IBUF + IBUFMAX - SCIFSZ;
   }
   else
      if (IBUFPNT < SCIFPNT)
	 SCIFPNT = IBUFPNT;
   printf("%c%-8.8s : %4X : %4X", '\15', SCIFPNT, IBUFPNT, SCIFPNT);
}

VOID InitMMI() {
   SCIFPNT = IBUFPNT = IBUF;
   KPMOD = 0;
   bKeySet = _MUKNA;
   SetMKey(_MUKIA);
}


VOID Maxinp() {        /* to define by user; called when IBUFMAX is exceeded */
   printf ("\a");
}

VOID Nothing() {			/* Dummy void empty function */
   KPMOD =0;
}

VOID Retry() {
   (*RTRFAD)();
}

/*---------------------------------------------------------- Cursor movement */
VOID _CrcPs() {
   BlinkLn(BL_OFF);
   ci = wwCpos;
   do {
      wwCpos = ++wwCpos % wwNrOpts;
      Filllnvar();
      if (wwCpos == ci)
	 break;
   } while (lnType & _ACOFF);
   BlinkLn(BL_ON);
}

VOID _CrcMn() {
   BlinkLn(BL_OFF);
   ci = wwCpos;
   do {
      wwCpos = (wwCpos + wwNrOpts-1) % wwNrOpts;
      Filllnvar();
      if (wwCpos == ci)
	 break;
   } while (lnType & _ACOFF);
   BlinkLn(BL_ON);
}

VOID Right() {
   if (wwPrev != NULL)
      if ((wwPrev->Prev == NULL) && (!(wwType & _WWMIP))) {
	 CloseWW();
	 Right();
	 Cr();
	 return;
      }
   if (!(wwType & _WWVRT))
      _CrcPs();
}

VOID Left() {
   if (wwPrev != NULL)
      if ((wwPrev->Prev == NULL) && (!(wwType & _WWMIP))) {
	 CloseWW();
	 Left();
	 Cr();
	 return;
      }
   if (!(wwType & _WWVRT))
      _CrcMn();
}

VOID Up() {
   _CrcMn();
}

VOID Down() {
   if (wwPrev == NULL)
      Cr();
   else {
      _CrcPs();
   }
}

VOID Home() {
   BlinkLn(BL_OFF);
   wwCpos = 0;
   Filllnvar();
   if (lnType & _ACOFF)
      _CrcPs();
   else
      BlinkLn(BL_ON);
}


