/*--- WLIB.C ------------------------------------------------------------------
function: Window functions library
credits:  FVu, Dec-1998 (freddy@textinfo.nl)
*/

#include <stdio.h>
#include <glib.h>
#include "vdp.h"
#include "vdpm.h"
#include "wwdb.h"
#include "wlib.h"


/*---------------------------------------------------------------- variables */
					/* easy window variables */
char	wwType;
int	wwPos;
char	wwLinLen;
char	wwNrLins;
WWLINE	*wwLin;
WWINFO	*wwPrev;
char	wwCpos;
char	wwNrOpts;

char   *wwText, *wwHP;
					/* easy window line variables */
char	*lnText;
char	lnKey;
char	lnType;
char	*lnAction;
int	lnbl1;
int	lnbl2;

WWINFO	*ActWW;

char	ci, cj, ck, cl, cm, cn; 	/* Global public variables */
int	ii, ij, ik;

char	*HP;				/* Heap */
char	*heap;

char	PsmBlink;			/* bias variable for mid blinks */

/*---------------------------------------------------------------- functions */
VOID WLInit() { 			/* Window library initialisation */
   if ((heap = sbrk(HEAP_LEN)) == ERROR) {
      puts ("Not enough (heap) memory.\n");
      exit();
   }
   HP = heap;
   Fillwwvar(ActWW = &ww0);
   Filllnvar();
}

VOID Filllnvar() {
   movmem(&wwLin[wwCpos], &lnText, sizeof WWLINE);
}

VOID Fillwwvar() {
   movmem(ActWW, &wwType, sizeof WWINFO);
}


VOID HPtoWW() {
   ci = wwNrLins;
   ii = wwPos + (WIDTH * ((int) wwNrLins -1));
   while (ci-- != 0) {
      HPVRAM (ii, (int) wwLinLen);
      ii -= WIDTH;
   }
}


VOID WWtoHP() {
   ci = wwNrLins;
   ii = wwPos;
   while (ci-- != 0) {
      VRAMHP (ii, (int) wwLinLen);
      ii += WIDTH;
   }
}

VOID BlinkWW(value)
char value;
{
   for (ci = wwNrLins, ii = wwPos; ci != 0; ci--, ii += WIDTH)
      Blink(value, ii, ii + wwLinLen-1);
}

VOID BlinkLn(value)
char value;
{
   if (wwType & _WWIBL)
      value = ~value;
   if (wwType & _WWVRT) {
      if (wwType & _WWFRM) {
	 ii = wwPos + 1 + (((int)wwCpos+1) * WIDTH);
	 ij = ii + wwLinLen - 3;
      }
      else {
	 ii = wwPos + ((int)wwCpos * WIDTH);
	 ij = ii + --wwLinLen;
      }
   }
   else {
      ii = lnbl1 + wwPos;
      ij = lnbl2 + wwPos;
      if (wwType & _WWMIP) {
	 ii += PsmBlink;
	 ij += PsmBlink;
      }
   }
   Blink(value, ii, ij);
}

VOID _ClASZ() {
	 ci = wwLinLen = wwNrLins = cm = 0;
	 ck = 1;
	 if (wwType & _WWVRT) {
	    while (cm < wwNrOpts) {
	       ci = (char) strlen(wwLin[cm++].Text);
	       if (ci > wwLinLen)
		  wwLinLen = ci;
	    }
	    if (wwNrOpts > wwNrLins)
	       wwNrLins = wwNrOpts;
	 }
	 else {
	    if (wwType & _WWTXT) {
	       wwText = wwLin[wwNrOpts].Text;
	       while (*wwText) {
		  if (*wwText++ == '\n') {
		     if (ci > wwLinLen)
			wwLinLen = ci;
		     ci = 0;
		     ck++;
		  }
		  else
		     ci++;
	       }
	       if (ci > wwLinLen)
		  wwLinLen = ci;
	       wwNrLins = ck;
	    }
	    while (cm < wwNrOpts) {
	       ck = (ii = wwLin[cm].blink1)/WIDTH;
	       ci = (ii%WIDTH) + strlen(wwLin[cm++].Text);
	       if (!(wwType & _WWFRM)) {
		  ck++;
		  ci++;
	       }
	       if (ci > wwLinLen)
		  wwLinLen = ci;
	       if (ck > wwNrLins)
		  wwNrLins = ck;
	    }
	 }
	 if (wwType & _WWFRM) {
	    wwLinLen += 4;
	    wwNrLins += 2;
	 }
	 if (wwLinLen > WIDTH)
	    wwLinLen = WIDTH;
	 if (wwNrLins > HEIGHT)
	    wwNrLins = HEIGHT;
	 ActWW->LinLen = wwLinLen;
	 ActWW->NrLins = wwNrLins;
}

VOID _ClPSC() {
	 wwPos = wwPrev->Pos;
	 ci = WIDTH - wwLinLen; 	      /* maxX */
	 cj = HEIGHT - wwNrLins;	      /* maxY */
	 if (lnType & _WWVRT)
	    ii = (int) WIDTH * (lnKey+2) + 2;
	 else
	    ii = lnbl1 + WIDTH;
	 wwPos = wwPos + ii;
	 ck = wwPos % WIDTH;		      /* wwX */
	 cl = wwPos / WIDTH;		      /* wwY */
	 wwPos = ((ck>ci)?ci:ck) + (int) ((cl>cj)?cj:cl) * WIDTH;
}

VOID _ClPSM() {
   wwPos = (int) (HEIGHT/2 - wwNrLins/2)*WIDTH + (WIDTH/2 - wwLinLen/2);
   if (!(wwType & _WWVRT))
      PsmBlink = (wwLinLen - wwLin[wwNrOpts-1].blink1%WIDTH +
	 strlen(wwLin[wwNrOpts-1].Text) - wwLin[0].blink1%WIDTH)/2 -2;
}


VOID _HpText() {
      wwHP = HP;
      if (wwType & _WWFRM) {
	 cn = 4;				  /* heap increment value */
	 cj = wwLinLen - 4;			  /* maximum LinLen */
	 cl = wwNrLins - 2;			  /* maximum NrLins */
	 wwHP += wwLinLen + 2;
      }
      else {
	 cn = 0;
	 cj = wwLinLen;
	 cl = wwNrLins;
      }
      cm = 0;					   /* wwOption counter */
      ck = 0;					   /* line counter */

      if (wwType & _WWVRT)
	 while (cm < wwNrOpts) {
	    if (ck++ >= cl)
	       break;
	    else {
	       ci = 0;
	       lnText = wwLin[cm++].Text;
	       while ((ci++ < cj) && (*lnText != '\0'))
		  *wwHP++ = *lnText++;
	       wwHP += (cn + cj - --ci);
	    }
	 }
      else {
	 if (wwType & _WWTXT) {
	    ci = 0;				  /* position counter */
	    lnText = wwLin[wwNrOpts].Text;
	    while (*lnText) {
	       if (*lnText == '\n')
		  if (ck++ >= cj)
		     break;
		  else
		     ci = 0;
	       if (ci++ < cj)
		  *wwHP++ = *lnText++;
	       else {
		  ci = 0;
		  while ((ci++ < cj) && (*lnText++ != '\0'))
		     lnText++;
	       }
	    }
	 }
	 while (cm < wwNrOpts) {
	    ck = (ii = wwLin[cm].blink1)/WIDTH;
	    ci = ii % WIDTH;
	    if (wwType & _WWMIP)
	       ci += PsmBlink;
	    if (wwType & _WWFRM) {
	       cl++;
	       cj += 2;
	    }
	    lnText = wwLin[cm++].Text;
	    if (ck < cl) {
	       wwHP = HP + (int) ck * wwLinLen + ci;
	       while ((ci++ < cj) && (*lnText != '\0'))
		  *wwHP++ = *lnText++;
	    }
	 }
      }
}

VOID _DrWWLine() {
   for (ci = wwLinLen -2; ci != 0; ci--)
      *wwHP++ = 0x17;
}

VOID OpenWW(window)
WWINFO *window; {

   if (window) {
      lnKey  = ActWW->Cpos = wwCpos;	      /* Backup prev WW settings */
      lnType = wwType;

      ActWW = window;
      Fillwwvar();

      if (wwType & _WWASZ)			/* Calculate Auto Size */
	 _ClASZ();

      if (wwType & _WWMUP)			/* Calculate position cursor */
	 _ClPSC();
      else
	 if (wwType & _WWMIP)			/* Calculate position mid */
	    _ClPSM();
      window->Pos = wwPos;

      WWtoHP(); 				/* Save underground */

      ii = 0;					/* Fill heap with spaces */
      ij = (int) wwNrLins * wwLinLen;
      wwHP = HP;
      while (ii++ < ij)
	 *wwHP++ = 0x20;

      if (wwType & _WWFRM) {			/* Fill heap with frame */
	 wwHP = HP;
	 *wwHP++ = 0x18;			   /* Top Line */
	 _DrWWLine();
	 *wwHP++ = 0x19;

	 if (wwType & _WWVRT) {
	    cm = -1;				      /* Option counter */
	    while (++cm < wwNrOpts) {
	       if (*wwLin[cm].Text != '\0') {
		  *wwHP++ = 0x16;
		  if ((ci = wwLin[cm].Type) & _ACOFF)
		  *wwHP = 0x7E;
		  wwHP += (wwLinLen - 2);
		  if (ci & _ACOWW)
		     *(wwHP-1) = 0x07;
		  *wwHP++ = 0x16;
	       }
	       else {
		  *wwHP++ = 0x14;
		  _DrWWLine();
		  *wwHP++ = 0x13;
	       }
	    }
	 }
	 else
	    for (ci = wwNrLins-2; ci-- != 0;) {
	       *wwHP++ = 0x16;
	       wwHP += wwLinLen - 2;
	       *wwHP++ = 0x16;
	    }
	 *wwHP++ = 0x1A;			  /* Bottom Line */
	 _DrWWLine();
	 *wwHP++ = 0x1B;
      }

      _HpText();				/* Fill heap with text */

      Filllnvar();

      if (wwType & _WWIBL)
	 BlinkWW(BL_ON);
      HP += (int) wwNrLins * wwLinLen;
      HPtoWW(); 				/* Output Window */
      if (wwType & _WWCUR)
	 BlinkLn(BL_ON);
   }
}


VOID CloseWW() {

   HPtoWW();				/* Restore underground */
   if (wwType & _WWIBL)
      BlinkWW(BL_OFF);
   if (!(wwType & _WWMIP))
      ActWW->Cpos = wwCpos;		/* Save cursor position */
   if (ActWW->Prev != NULL) {		/* Activate previous window: */
      if (!(wwType & _WWIBL))
	 BlinkLn(BL_OFF);
      Fillwwvar(ActWW = ActWW->Prev);
      wwPos = ActWW->Pos;
      Filllnvar();
   }
}
